﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv35
{
    public class Stub_event
    {
        // nerv_stub_event delegate
        public delegate Int32 on_link_ft(IntPtr _event_, Address _proxy_addr, Double _packet_live_time, Double _packet_limit_time);

        public delegate void on_unlink_ft(IntPtr _event_, Address _proxy_addr, Int32 _err);


        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object, on_link_ft _on_link_, on_unlink_ft _on_unlink_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_free")]
        public static extern void free(IntPtr _event_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_unlink")]
        public static extern void unlink(IntPtr _event_, Address _proxy_addr);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_unlink_all_proxy")]
        public static extern void unlink_all_proxy(IntPtr _event_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_event")]
        public static extern Int32 notify(IntPtr _event_, IntPtr _evt_data_, UInt32 _evt_size);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_event_event_nodata")]
        public static extern Int32 notity_nodata(IntPtr _event_);
    }
}