#pragma once

#include "Proxy.hh"

namespace Nerv35 {

class NERV_SDK_DLL Proxy_datagram
    : virtual public Proxy {
	friend class _Proxy_datagram;

public:
	Proxy_datagram(msg_code_t _code);
	Proxy_datagram(msg_code_t               _code,
	                            const Proxy& __proxy_object);
	virtual ~Proxy_datagram(void);

protected:
	virtual void on_datagram(addr_t _stub_addr,
	                          const void* _buf_,
	                          pksize_t    _size,
	                          double      _elapsed_time);

private:
	_Proxy_datagram* _mp;
};

} // namespace Nerv35
