#pragma once

#include "Proxy.hh"

namespace Nerv35 {

class NERV_SDK_DLL Proxy_signal : virtual public Proxy {
public:
	Proxy_signal(msg_code_t _code);
	Proxy_signal(msg_code_t               _code,
	                         const Proxy& __proxy_object);
	virtual ~Proxy_signal(void);
	const return_promise_t async_signal(const void* _signal_data_,
	                                    pksize_t    _call_size,
	                                    double      _limit_time = 1.0);
	nerv_err_t async_return(return_promise_t _ret_promise, double* _time_ = 0);
	nerv_err_t signal(const void*    _signal_data_,
	                  pksize_t const _signal_size,
	                  double         _limit_time = 1.0,
	                  double*        _time_ = 0);
	void       cancel(nerv_err_t _error);

private:
	_Proxy_signal* _mp;
};

} // namespace Nerv35
