﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv35
{
    public class Proxy_call
    {
        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_free")]
        public static extern void free(IntPtr _call_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_async_call")]
        public static extern IntPtr async_call(IntPtr _call_, IntPtr _cal_data_, UInt32 _cal_size, Double _limit_time);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_async_return")]
        public static extern Int32 async_return(IntPtr _call_, IntPtr _promise_, IntPtr _ret_data_, ref UInt32 _ret_size_, ref Double _time_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_call_cancel")]
        public static extern void cancel(IntPtr _call_, Int32 _error);
    }
}
