﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv35
{
    public class Proxy_signal
    {
        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_free")]
        public static extern void free(IntPtr _signal_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_async_signal")]
        public static extern IntPtr async_signal(IntPtr _signal_, IntPtr _sig_data_, UInt32 _sig_size, Double _limit_time);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_async_return")]
        public static extern Int32 async_return(IntPtr _signal_, IntPtr _promise_, ref Double _time_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_signal")]
        public static extern Int32 signal(IntPtr _signal_, IntPtr _sig_data_, UInt32 _sig_size, Double _limit_time, ref Double _time_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_signal_cancel")]
        public static extern void cancel(IntPtr _signal_, Int32 _error);
    }
}
