﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv35
{
    public class Stub_call
    {
        // nerv_stub_call delegate
        public delegate Int32 on_call_ft(IntPtr _call_, Address _proxy_addr, IntPtr _cal_data_, UInt32 _cal_size, IntPtr _ret_data_, ref UInt32 _ret_size_, Double _elapsed_time, Double _packet_limit_time);

        public delegate void on_cancel_ft(IntPtr _call_, Address _proxy_addr, Int32 _error);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_call_alloc")]
        public static extern IntPtr alloc(UInt16 _code, UInt32 _max_return_size, IntPtr _object_, on_call_ft _on_call_, on_cancel_ft _on_cancel_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_call_free")]
        public static extern void free(IntPtr _call_);
    }
}
