#pragma once

#include "Proxy.hh"

namespace Nerv35 {

class NERV_SDK_DLL Proxy_call : public virtual Proxy {
public:
	Proxy_call(msg_code_t _code);
	Proxy_call(msg_code_t               _code,
	                       const Proxy& __proxy_object);
	virtual ~Proxy_call();
	const return_promise_t async_call(const void* _call_data_,
	                                  pksize_t    _call_size,
	                                  double      _limit_time = 1.0);
	nerv_err_t             async_return(return_promise_t ret_promise,
	                                    void*            _return_data_,
	                                    pksize_t*        _size_,
	                                    double*          _time_);
	void                   cancel(nerv_err_t _error);

private:
	_Proxy_call* _mp;
};

} // namespace Nerv35
