#pragma once

#include "Stub.hh"

namespace Nerv35 {

class NERV_SDK_DLL Stub_datagram : virtual public Stub {
	friend class _Stub_datagram;

public:
	Stub_datagram(msg_code_t _code);
	Stub_datagram(msg_code_t _code, const Stub& __Stub);
	virtual ~Stub_datagram(void);
	nerv_err_t broadcast(const void* _data_, pksize_t _size);
	nerv_err_t cast(ip_t _ip, const void* _data_, pksize_t _size);

private:
	_Stub_datagram* _mp;
};

} // namespace Nerv35
