#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"


namespace Nerv35 {

NERV_SDK_DLL size_t get_address(const char* _name_, addr_t* _stub_addr_);

NERV_SDK_DLL ip_t  inet_addr(const char* _ip_);
NERV_SDK_DLL char* inet_ntoa(ip_t _ip);

NERV_SDK_DLL nerv_clock_t get_cpu_clock();
NERV_SDK_DLL nerv_clock_t get_cpu_hz();

NERV_SDK_DLL void initialize();
NERV_SDK_DLL void initialize(size_t _thread_count,
                             size_t _call_buffer_count,
                             size_t _udp_buffer_count);
NERV_SDK_DLL void finalize();

} // namespace Nerv35
